# ##########################
# Configuration      #
# ##########################
TEMPLATE = app
TARGET = 
CONFIG(debug, debug|release): DEFINES += DEBUG

macx:DEFINES += MACX
win32:DEFINES += WIN32

win32{
    CONFIG(Debug, Debug|Release){
        MOC_DIR = Debug
        UI_DIR = Debug
        RCC_DIR = Debug
        OBJECTS_DIR = Debug
    }else{
        MOC_DIR = Release
        UI_DIR = Release
        RCC_DIR = Release
        OBJECTS_DIR = Release
    }
}else{
    MOC_DIR = build
    UI_DIR = build
    RCC_DIR = build
    OBJECTS_DIR = build
}
macx:ICON = logo.icns
win32:RC_FILE = MachineLearning.rc
RESOURCES += mldemos.qrc
DEPENDPATH += .
win32{
INCLUDEPATH += . \
    "C:/Program Files/OpenCV2.0/include/"
LIBS += -L"C:/Progra~1/OpenCV2.0/lib/"
LIBS += -lcv200 \
    -lcxcore200 \
    -lcvaux200 \
    -lhighgui200 \
    -lml200
}else{
INCLUDEPATH += . \
    /usr/include/qt4/ \
    /usr/include/qt4/QtCore/ \
    /usr/include/qt4/QtGui/ \
    /usr/include/qt4/QtOpenGL \
    /usr/include/opencv/ \
    /usr/local/include/opencv/
LIBS += -L/usr/local/lib
LIBS += -lcv \
    -lcxcore \
    -lcvaux \
    -lhighgui \
    -lml
}
macx:INCLUDEPATH += uiMac

###########################
#        Plugins          #
###########################
macx {
	plugins.path = Contents/Resources/plugins
	plugins.files = \
					plugins/libIO_PCAFaces.dylib \
					plugins/libIO_RandomEmitter.dylib \
					plugins/libmld_GMM.dylib \
					plugins/libmld_KernelMethods.dylib \
					plugins/libmld_KNN.dylib \
					plugins/libmld_LinearMethods.dylib \
					plugins/libmld_LWPR.dylib \
					plugins/libmld_SEDS.dylib

	QMAKE_BUNDLE_DATA += plugins
}
# ##########################
# Source Files       #
# ##########################
macx{
FORMS += uiMac/aboutDialog.ui \
	uiMac/optionsClassify.ui \
	uiMac/optionsCluster.ui \
	uiMac/optionsRegress.ui \
	uiMac/optionsDynamic.ui \
	uiMac/mldemos.ui \
	uiMac/drawingTools.ui \
	uiMac/drawingToolsContext1.ui \
	uiMac/drawingToolsContext2.ui \
	uiMac/sampleDrawing.ui \
	uiMac/statisticsDialog.ui \
	uiMac/viewOptions.ui
}
else {
FORMS += aboutDialog.ui \
    mldemos.ui \
    sampleDrawing.ui \
    statisticsDialog.ui \
    viewOptions.ui \
	drawingTools.ui \
	drawingToolsContext1.ui \
	drawingToolsContext2.ui \
	optionsClassify.ui \
    optionsCluster.ui \
    optionsRegress.ui \
    optionsDynamic.ui
}
HEADERS += basicMath.h \
    basicOpenCV.h \
    canvas.h \
    datasetManager.h \
    gettimeofday.h \
    drawUtils.h \
    drawTimer.h \
    mldemos.h \
    mymaths.h \
    public.h \
    roc.h \
    sampleManager.h \
    types.h \
    widget.h \
    interfaces.h \
    classifier.h \
    regressor.h \
    dynamical.h \
    clusterer.h
SOURCES += basicOpenCV.cpp \
    canvas.cpp \
    datasetManager.cpp \
    drawUtils.cpp \
    drawTimer.cpp \
    main.cpp \
    mldemos.cpp \
    mlprocessing.cpp \
    mlstats.cpp \
    mlsaving.cpp \
    mymaths.cpp \
    roc.cpp \
    sampleManager.cpp \
    widget.cpp

# ##########################
# Dependencies             #
# ##########################
HEADERS += fgmm/em.h \
    fgmm/fgmm++.hpp \
    fgmm/fgmm.h \
    fgmm/gaussian.h \
    fgmm/regression.h \
    fgmm/smat.h
SOURCES += fgmm/em.cpp \
    fgmm/gaussian.cpp \
    fgmm/gmm.cpp \
    fgmm/gmmregression.cpp \
    fgmm/smat.cpp \
    fgmm/update.cpp

# ###############################
# Turn the bloody warnings off #
# ###############################
win32 {

}else{
    QMAKE_CXXFLAGS_WARN_ON = ""
    QMAKE_CXXFLAGS += -Wno-all
    QMAKE_CXXFLAGS += -Wno-endif-labels
    QMAKE_CXXFLAGS += -Wno-unused-variable
    QMAKE_CXXFLAGS += -Wno-unused-parameter
    QMAKE_CXXFLAGS += -Wno-switch
    QMAKE_CXXFLAGS += -Wtrigraphs
    QMAKE_CXXFLAGS += -Wreturn-type

    # QMAKE_CXXFLAGS += -Wnon-virtual-dtor
    QMAKE_CXXFLAGS += -Woverloaded-virtual

    # QMAKE_CXXFLAGS += -Wunused-variable
    # QMAKE_CXXFLAGS += -Wunused-value
    QMAKE_CXXFLAGS += -Wunknown-pragmas
    QMAKE_CXXFLAGS += -Wno-shadow
    QMAKE_CXXFLAGS += -Wno-deprecated-declarations
    QMAKE_CXXFLAGS += -Wno-missing-braces
}
