# ##########################
# Configuration      #
# ##########################
TEMPLATE = lib
CONFIG += plugin
TARGET = $$qtLibraryTarget(mld_KNN)
CONFIG(debug, debug|release):DESTDIR = ../../pluginsDebug
CONFIG(release, debug|release):DESTDIR = ../../plugins
macx:DEFINES += MACX
win32:DEFINES += WIN32

win32{
    CONFIG(Debug, Debug|Release){
        MOC_DIR = Debug
        UI_DIR = Debug
        RCC_DIR = Debug
        OBJECTS_DIR = Debug
    }else{
        MOC_DIR = Release
        UI_DIR = Release
        RCC_DIR = Release
        OBJECTS_DIR = Release
    }
}else{
    MOC_DIR = build
    UI_DIR = build
    RCC_DIR = build
    OBJECTS_DIR = build
}
DEPENDPATH += . \
        ..
win32{
INCLUDEPATH += . \
    "C:/Program Files/OpenCV2.0/include/"
LIBS += -L"C:/Progra~1/OpenCV2.0/lib/"
LIBS += -lcv200 \
    -lcxcore200 \
    -lcvaux200 \
    -lhighgui200 \
    -lml200
}else{
INCLUDEPATH += . \
    /usr/include/qt4/ \
    /usr/include/qt4/QtCore/ \
    /usr/include/qt4/QtGui/ \
    /usr/include/qt4/QtOpenGL \
    /usr/include/opencv/ \
    /usr/local/include/opencv/
LIBS += -L/usr/local/lib
LIBS += -lcv \
    -lcxcore \
    -lcvaux \
    -lhighgui \
    -lml
}
INCLUDEPATH += ../..

###########################
# Source Files            #
###########################
FORMS += paramsKNN.ui paramsKNNDynamic.ui paramsKNNRegress.ui
HEADERS +=	mymaths.h \
			classifierKNN.h \
			regressorKNN.h \
			dynamicalKNN.h \
			interfaceKNNClassifier.h \
			interfaceKNNRegress.h \
			interfaceKNNDynamic.h \
			pluginKNN.h

SOURCES += 	mymaths.cpp \
			classifierKNN.cpp \
			regressorKNN.cpp \
			dynamicalKNN.cpp \
			interfaceKNNClassifier.cpp \
			interfaceKNNRegress.cpp \
			interfaceKNNDynamic.cpp \
			pluginKNN.cpp

###########################
# Dependencies            #
###########################
HEADERS += ANN/ANN.h \
	ANN/ANNperf.h \
	ANN/ANNx.h \
	ANN/bd_tree.h \
	ANN/kd_fix_rad_search.h \
	ANN/kd_pr_search.h \
	ANN/kd_search.h \
	ANN/kd_split.h \
	ANN/kd_tree.h \
	ANN/kd_util.h \
	ANN/pr_queue.h \
	ANN/pr_queue_k.h

SOURCES += ANN/ANN.cpp \
	ANN/bd_fix_rad_search.cpp \
	ANN/bd_pr_search.cpp \
	ANN/bd_search.cpp \
	ANN/bd_tree.cpp \
	ANN/brute.cpp \
	ANN/kd_dump.cpp \
	ANN/kd_fix_rad_search.cpp \
	ANN/kd_pr_search.cpp \
	ANN/kd_search.cpp \
	ANN/kd_split.cpp \
	ANN/kd_tree.cpp \
	ANN/kd_util.cpp \
	ANN/perf.cpp

################################
# Turn the bloody warnings off #
################################
macx|unix {
    QMAKE_CXXFLAGS_WARN_ON = ""
    QMAKE_CXXFLAGS += -Wno-all
    QMAKE_CXXFLAGS += -Wno-endif-labels
    QMAKE_CXXFLAGS += -Wno-unused-variable
    QMAKE_CXXFLAGS += -Wno-unused-parameter
    QMAKE_CXXFLAGS += -Wno-switch
    QMAKE_CXXFLAGS += -Wtrigraphs
    QMAKE_CXXFLAGS += -Wreturn-type
    #QMAKE_CXXFLAGS += -Wnon-virtual-dtor
    QMAKE_CXXFLAGS += -Woverloaded-virtual
    #QMAKE_CXXFLAGS += -Wunused-variable
    #QMAKE_CXXFLAGS += -Wunused-value
    QMAKE_CXXFLAGS += -Wunknown-pragmas
    QMAKE_CXXFLAGS += -Wno-shadow
    QMAKE_CXXFLAGS += -Wno-deprecated-declarations
    QMAKE_CXXFLAGS += -Wno-missing-braces
}
