# ##########################
# Configuration      #
# ##########################
TEMPLATE = lib
CONFIG += plugin
TARGET = $$qtLibraryTarget(mld_LWPR)
CONFIG(debug, debug|release):DESTDIR = ../../pluginsDebug
CONFIG(release, debug|release):DESTDIR = ../../plugins
macx:DEFINES += MACX
win32:DEFINES += WIN32

win32{
    CONFIG(Debug, Debug|Release){
        MOC_DIR = Debug
        UI_DIR = Debug
        RCC_DIR = Debug
        OBJECTS_DIR = Debug
    }else{
        MOC_DIR = Release
        UI_DIR = Release
        RCC_DIR = Release
        OBJECTS_DIR = Release
    }
}else{
    MOC_DIR = build
    UI_DIR = build
    RCC_DIR = build
    OBJECTS_DIR = build
}
DEPENDPATH += . \
        ..
win32{
INCLUDEPATH += . \
    "C:/Program Files/OpenCV2.0/include/"
LIBS += -L"C:/Progra~1/OpenCV2.0/lib/"
LIBS += -lcv200 \
    -lcxcore200 \
    -lcvaux200 \
    -lhighgui200 \
    -lml200
}else{
INCLUDEPATH += . \
    /usr/include/qt4/ \
    /usr/include/qt4/QtCore/ \
    /usr/include/qt4/QtGui/ \
    /usr/include/qt4/QtOpenGL \
    /usr/include/opencv/ \
    /usr/local/include/opencv/
LIBS += -L/usr/local/lib
LIBS += -lcv \
    -lcxcore \
    -lcvaux \
    -lhighgui \
    -lml
}
INCLUDEPATH += ../..
###########################
# Source Files            #
###########################
FORMS += paramsLWPRDynamic.ui paramsLWPRRegress.ui
HEADERS +=	mymaths.h \
			regressorLWPR.h \
			dynamicalLWPR.h \
			interfaceLWPRRegress.h \
			interfaceLWPRDynamic.h \
			pluginLWPR.h

SOURCES += 	mymaths.cpp \
			regressorLWPR.cpp \
			dynamicalLWPR.cpp \
			interfaceLWPRRegress.cpp \
			interfaceLWPRDynamic.cpp \
			pluginLWPR.cpp

###########################
# Dependencies            #
###########################
HEADERS += \
	lwpr/lwpr.h \
	lwpr/lwpr.hh \
	lwpr/lwpr_aux.h \
	lwpr/lwpr_binio.h \
	lwpr/lwpr_config.h \
	lwpr/lwpr_config_def.h \
	lwpr/lwpr_math.h \
	lwpr/lwpr_mem.h \
	lwpr/lwpr_xml.h

SOURCES +=  \
	lwpr/lwpr.c \
	lwpr/lwpr_aux.c \
	lwpr/lwpr_binio.c \
	lwpr/lwpr_math.c \
	lwpr/lwpr_mem.c \
	lwpr/lwpr_xml.c


################################
# Turn the bloody warnings off #
################################
macx|unix {
    QMAKE_CXXFLAGS_WARN_ON = ""
    QMAKE_CXXFLAGS += -Wno-all
    QMAKE_CXXFLAGS += -Wno-endif-labels
    QMAKE_CXXFLAGS += -Wno-unused-variable
    QMAKE_CXXFLAGS += -Wno-unused-parameter
    QMAKE_CXXFLAGS += -Wno-switch
    QMAKE_CXXFLAGS += -Wtrigraphs
    QMAKE_CXXFLAGS += -Wreturn-type
    #QMAKE_CXXFLAGS += -Wnon-virtual-dtor
    QMAKE_CXXFLAGS += -Woverloaded-virtual
    #QMAKE_CXXFLAGS += -Wunused-variable
    #QMAKE_CXXFLAGS += -Wunused-value
    QMAKE_CXXFLAGS += -Wunknown-pragmas
    QMAKE_CXXFLAGS += -Wno-shadow
    QMAKE_CXXFLAGS += -Wno-deprecated-declarations
    QMAKE_CXXFLAGS += -Wno-missing-braces
}
