# ##########################
# Configuration      #
# ##########################
TEMPLATE = lib
CONFIG += plugin
TARGET = $$qtLibraryTarget(mld_SEDS)
CONFIG(debug, debug|release):DESTDIR = ../../pluginsDebug
CONFIG(release, debug|release):DESTDIR = ../../plugins
macx:DEFINES += MACX
win32:DEFINES += WIN32

win32{
    CONFIG(Debug, Debug|Release){
        MOC_DIR = Debug
        UI_DIR = Debug
        RCC_DIR = Debug
        OBJECTS_DIR = Debug
    }else{
        MOC_DIR = Release
        UI_DIR = Release
        RCC_DIR = Release
        OBJECTS_DIR = Release
    }
}else{
    MOC_DIR = build
    UI_DIR = build
    RCC_DIR = build
    OBJECTS_DIR = build
}
DEPENDPATH += . \
        ..
win32{
INCLUDEPATH += . \
    "C:/Program Files/OpenCV2.0/include/"
LIBS += -L"C:/Progra~1/OpenCV2.0/lib/"
LIBS += -lcv200 \
    -lcxcore200 \
    -lcvaux200 \
    -lhighgui200 \
    -lml200
}else{
INCLUDEPATH += . \
    /usr/include/qt4/ \
    /usr/include/qt4/QtCore/ \
    /usr/include/qt4/QtGui/ \
    /usr/include/qt4/QtOpenGL \
    /usr/include/opencv/ \
    /usr/local/include/opencv/
LIBS += -L/usr/local/lib
LIBS += -lcv \
    -lcxcore \
    -lcvaux \
    -lhighgui \
    -lml
}
INCLUDEPATH += ../..
###########################
# Source Files            #
###########################
FORMS += paramsSEDS.ui
HEADERS +=	\
			mymaths.h \
			basicOpenCV.h \
			drawEllipse.h \
			SEDS.h \
			dynamicalSEDS.h \
			interfaceSEDSDynamic.h

SOURCES += 	\
			mymaths.cpp \
			basicOpenCV.cpp \
			SEDS.cpp \
			dynamicalSEDS.cpp \
			interfaceSEDSDynamic.cpp

###########################
# Dependencies            #
###########################
HEADERS +=	\
	fgmm/em.h \
	fgmm/fgmm++.hpp \
	fgmm/fgmm.h \
	fgmm/gaussian.h \
	fgmm/regression.h \
	fgmm/smat.h \
	MathLib/Differentiator.h \
	MathLib/GradientDescent.h \
	MathLib/IKGroupSolver.h \
	MathLib/IKSubSolver.h \
	MathLib/Macros.h \
	MathLib/MathLib.h \
	MathLib/MathLibCommon.h \
	MathLib/Matrix.h \
	MathLib/Matrix3.h \
	MathLib/Matrix4.h \
	MathLib/ReferenceFrame.h \
	MathLib/Regression.h \
	MathLib/SpatialForce.h \
	MathLib/SpatialFrame.h \
	MathLib/SpatialInertia.h \
	MathLib/SpatialMatrix.h \
	MathLib/SpatialVector.h \
	MathLib/SpatialVelocity.h \
	MathLib/TMatrix.h \
	MathLib/TVector.h \
	MathLib/Vector.h \
	MathLib/Vector3.h

SOURCES += \
	fgmm/em.cpp \
	fgmm/gaussian.cpp \
	fgmm/gmm.cpp \
	fgmm/gmmregression.cpp \
	fgmm/smat.cpp \
	fgmm/update.cpp \
	MathLib/Differentiator.cpp \
	MathLib/GradientDescent.cpp \
	MathLib/IKGroupSolver.cpp \
	MathLib/IKSubSolver.cpp \
	MathLib/Macros.cpp \
	MathLib/MathLib.cpp \
	MathLib/MathLibCommon.cpp \
	MathLib/Matrix.cpp \
	MathLib/Matrix3.cpp \
	MathLib/Matrix4.cpp \
	MathLib/ReferenceFrame.cpp \
	MathLib/Regression.cpp \
	MathLib/SpatialForce.cpp \
	MathLib/SpatialFrame.cpp \
	MathLib/SpatialInertia.cpp \
	MathLib/SpatialMatrix.cpp \
	MathLib/SpatialVector.cpp \
	MathLib/SpatialVelocity.cpp \
	MathLib/TMatrix.cpp \
	MathLib/TVector.cpp \
	MathLib/Vector.cpp \
	MathLib/Vector3.cpp

################################
# Turn the bloody warnings off #
################################
macx|unix {
    QMAKE_CXXFLAGS_WARN_ON = ""
    QMAKE_CXXFLAGS += -Wno-all
    QMAKE_CXXFLAGS += -Wno-endif-labels
    QMAKE_CXXFLAGS += -Wno-unused-variable
    QMAKE_CXXFLAGS += -Wno-unused-parameter
    QMAKE_CXXFLAGS += -Wno-switch
    QMAKE_CXXFLAGS += -Wtrigraphs
    QMAKE_CXXFLAGS += -Wreturn-type
    #QMAKE_CXXFLAGS += -Wnon-virtual-dtor
    QMAKE_CXXFLAGS += -Woverloaded-virtual
    #QMAKE_CXXFLAGS += -Wunused-variable
    #QMAKE_CXXFLAGS += -Wunused-value
    QMAKE_CXXFLAGS += -Wunknown-pragmas
    QMAKE_CXXFLAGS += -Wno-shadow
    QMAKE_CXXFLAGS += -Wno-deprecated-declarations
    QMAKE_CXXFLAGS += -Wno-missing-braces
}
