#ifndef _EIGEN_FACES_H_
#define _EIGEN_FACES_H_

#include <vector>

class EigenFaces
{
private:
	u32 dim;
	u32 trainCnt;
	IplImage **eigenVectors;
	IplImage *avgImage;
	CvMat *eigenValues;
	std::vector<float *> projections;
	std::vector<u32> classes;
	std::vector<bool> isTraining;
	bool bUseColor;

	u32 FindNearestNeighbor(float *candidate);

public:
	EigenFaces();
	~EigenFaces();
	void Learn(std::vector<IplImage *> faces, std::vector<u32> classes, std::vector<bool> isTrainingData=std::vector<bool>(), bool bColor = true);
	void Recognize(IplImage *face);
	void Draw(bool bMonochrome=false, u32 e1 = 0, u32 e2 = 1);
	void DrawEigenVals();
	std::vector<IplImage *> GetEigenVectorsImages();

	std::vector<float *> GetProjections(u32 dim = 0, bool bNormalized=false);
	std::vector<u32> GetClasses(){return classes;};
	IplImage **GetVectors(){return eigenVectors;};
	u32 GetVectorCount(){return dim;};

	IplImage *mapImage;

};
#endif _EIGEN_FACES_H_
